//+------------------------------------------------------------------+
//|        Teresh-miracle based on fairy tales Xard777 and Fadly.mq4 |
//|                                       Special thanks guru Mladen |
//|                                                                  |
//|                                                                  |
//| original T3 developed by Tim Tilson (TASC January 1998)          |
//| period lag modification by Bob Fulks and Alex Matulich 4/2003    |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Maroon
#property indicator_color2 DarkGreen
#property indicator_color3 DarkGreen

#property indicator_color4 Red
#property indicator_color5 LimeGreen
#property indicator_color6 Gold
#property indicator_level1 0
#property indicator_level2 0.002
#property indicator_level3 -0.002


#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2


extern int Lag=20;
   extern int NumComps=2;
   extern  int PeriodNorm=20;
   extern int N=300;
extern double k = 0.005;
extern int    T3FastPeriod   = 34;
extern int    T3FastPrice    = PRICE_CLOSE;
extern double T3FastHot      = 1.9;
extern int    T3SlowPeriod   = 55;
extern int    T3SlowPrice    = PRICE_CLOSE;
extern double T3SlowHot      = 1.9;

extern int TimeFrame = 0;

extern string note_timeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string note_price = "0C 1O 2H 3L 4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6";


 bool   T3FastOriginal = 0;
 bool   T3SlowOriginal = 0;


//

double t3fast[];
double t3slow[];
double t3gCross[];
double t3rCross[];
double SASU[];

double ind_buffer1[];
double ind_buffer2[];
double ind_buffer3[];
double ind_buffer4[];



double emas[][12];
double alphaFast,alphaSlow;
double c1fast,c1slow;
double c2fast,c2slow;
double c3fast,c3slow;
double c4fast,c4slow;
string IndicatorFileName;



int init()
{
   IndicatorBuffers(8);
      

      SetIndexBuffer(0,t3rCross); //SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,218);
      SetIndexBuffer(1,ind_buffer3);
      SetIndexBuffer(2,ind_buffer4);


      SetIndexBuffer(3,t3gCross); //SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,217);
      SetIndexBuffer(4,ind_buffer1);
      SetIndexBuffer(5,SASU);



      SetIndexBuffer(6,t3fast);  
      SetIndexBuffer(7,t3slow);
        

   
      T3FastPeriod = MathMax(1,T3FastPeriod);
      if (T3FastOriginal)
           alphaFast = 2.0/(1.0 + T3FastPeriod);
      else alphaFast = 2.0/(2.0 + (T3FastPeriod-1.0)/2.0);

      double a  = T3FastHot;
             c1fast = -a*a*a;
             c2fast = 3*a*a+3*a*a*a;
             c3fast = -6*a*a-3*a-3*a*a*a;
             c4fast = 1+3*a+a*a*a+3*a*a;


      
      T3SlowPeriod = MathMax(1,T3SlowPeriod);
      if (T3SlowOriginal)
           alphaSlow = 2.0/(1.0 + T3SlowPeriod);
      else alphaSlow = 2.0/(2.0 + (T3SlowPeriod-1.0)/2.0);

             a  = T3SlowHot;
             c1slow = -a*a*a;
             c2slow = 3*a*a+3*a*a*a;
             c3slow = -6*a*a-3*a-3*a*a*a;
             c4slow = 1+3*a+a*a*a+3*a*a;

   TimeFrame = MathMax(TimeFrame,Period());
         
   IndicatorShortName("Teresh-miracle based on fairy tales Xard777 and Fadly ("+T3FastPeriod+", "+DoubleToStr(T3FastHot,2)+"; "+T3SlowPeriod+", "+DoubleToStr(T3SlowHot,2)+")"+" M"+TimeFrame);

   SetIndexLabel(0,"T3 trix "+T3SlowPeriod);
   SetIndexLabel(3,"T3 trix "+T3FastPeriod);



   IndicatorFileName = WindowExpertName();


   return(0);
}



int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);


   if (TimeFrame != Period())
      {
         limit = MathMax(limit,TimeFrame/Period()-1);
        for(i=limit-1; i>=0; i--)
         {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
   
         t3rCross[i]    = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,0,y);
         ind_buffer3[i] = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,1,y);
         ind_buffer4[i] = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,2,y);

         t3gCross[i]    = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,3,y);
         ind_buffer1[i] = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,4,y);
         ind_buffer2[i] = iCustom(NULL,TimeFrame,IndicatorFileName,T3FastPeriod,T3FastPrice,T3FastHot,T3SlowPeriod,T3SlowPrice,T3SlowHot,5,y);
 
 
         }

         return(0);         
      }



   if (t3gCross[limit] > t3gCross[limit+1]) CleanPoint(limit,ind_buffer1,ind_buffer2);
   if (t3rCross[limit] > t3gCross[limit+1]) CleanPoint(limit,ind_buffer3,ind_buffer4);

// 

   for(i=limit; i>=0; i--)
   {
      t3fast[i]   = iT3(iMA(NULL,0,1,0,MODE_SMA,T3FastPrice,i),i,0,alphaFast,c1fast,c2fast,c3fast,c4fast);
      t3slow[i]   = iT3(iMA(NULL,0,1,0,MODE_SMA,T3SlowPrice,i),i,6,alphaSlow,c1slow,c2slow,c3slow,c4slow);
      
      t3gCross[i]    = EMPTY_VALUE;    t3rCross[i]    = EMPTY_VALUE;      
      ind_buffer1[i] = EMPTY_VALUE;    ind_buffer2[i] = EMPTY_VALUE;
      ind_buffer3[i] = EMPTY_VALUE;    ind_buffer4[i] = EMPTY_VALUE;

   
      
   }    
   
    
   for(i=limit; i>=0; i--)

   {
         t3gCross[i] = t3fast[i] -t3fast[i+1];
         t3rCross[i] = t3slow[i] -t3slow[i+1];
                                   
      if (t3gCross[i]  > t3gCross[i+1])      PlotPoint(i,ind_buffer1,ind_buffer2,t3gCross);
      if (t3rCross[i]  > t3rCross[i+1])      PlotPoint(i,ind_buffer3,ind_buffer4,t3rCross);

   }
for(i=limit; i>=0; i--)
   {
            SASU[i]= iCustom(NULL,0,"#4X 2011 XARD SSA",Lag,NumComps,PeriodNorm, N,0,i)*k;
           
   }    
     
   return(0);
}



double iT3(double price,int shift,int startBuff,double alpha,double c1,double c2,double c3,double c4)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][startBuff+0] = price;
         emas[i][startBuff+1] = price;
         emas[i][startBuff+2] = price;
         emas[i][startBuff+3] = price;
         emas[i][startBuff+4] = price;
         emas[i][startBuff+5] = price;
      }
   else
      {
         emas[i][startBuff+0] = emas[i-1][startBuff+0]+alpha*(price               -emas[i-1][startBuff+0]);
         emas[i][startBuff+1] = emas[i-1][startBuff+1]+alpha*(emas[i][startBuff+0]-emas[i-1][startBuff+1]);
         emas[i][startBuff+2] = emas[i-1][startBuff+2]+alpha*(emas[i][startBuff+1]-emas[i-1][startBuff+2]);
         emas[i][startBuff+3] = emas[i-1][startBuff+3]+alpha*(emas[i][startBuff+2]-emas[i-1][startBuff+3]);
         emas[i][startBuff+4] = emas[i-1][startBuff+4]+alpha*(emas[i][startBuff+3]-emas[i-1][startBuff+4]);
         emas[i][startBuff+5] = emas[i-1][startBuff+5]+alpha*(emas[i][startBuff+4]-emas[i-1][startBuff+5]);
      }
   return(c1*emas[i][startBuff+5] + c2*emas[i][startBuff+4] + c3*emas[i][startBuff+3] + c4*emas[i][startBuff+2]);
}


void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}


void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}